// Fast access to functions using const refs
// Source is: 06_16.CPP

#include <iostream.h>
#include <time.h>

// Function declarations
int Function1(const double, const double);
int Function2(const double&, const double&);

int main()
   {
   double temp1 = 1.0, temp2 = 2.0;
   const long NUM_PASSES = 10000000;
   double   elapsed_time;

   time_t   start_time, stop_time; // time_t is defined in time.h

   // METHOD ONE 
   start_time = time(NULL);
   
   for (long pass = 0; pass <= NUM_PASSES; pass++)
      { 
      Function1(temp1, temp2);
      }

   stop_time = time(NULL);
   elapsed_time = difftime(stop_time, start_time);
   cout << "Value, time (in seconds) : " << elapsed_time << endl; 
    
   // METHOD TWO
   start_time = time(NULL);
   
   for (pass = 0; pass <= NUM_PASSES; pass++)
      { 
      Function2(temp1, temp2);
      }
             
   stop_time = time(NULL);   
   elapsed_time = difftime(stop_time, start_time);
   cout << "Reference, time (in seconds) : " << elapsed_time << endl; 
    
   return 0;
   }

int Function1(const double A, const double B)
    {
    double x = A;
    double y = B;

    return 0;
    }

int Function2(const double& A_REF, const double& B_REF)
    {
    double x = A_REF;
    double y = B_REF;

    return 0;
    }
