// Copying multi-dimensional arrays using pointer arithmetic 
// and "normal" indexing. Compares the speed of each technique. 
// Source is: 07_12.CPP 

#include <iostream.h>   
#include <time.h>

int main()
   {
   const int   DIM1 = 10;
   const int   DIM2 = 10;
   const int   DIM3 = 10; 
   
   const long  NUM_PASSES = 100000;

   int      Original[DIM1][DIM2][DIM3] = {0};
   int      Copy[DIM1][DIM2][DIM3];
   int*     Orig_PTR;
   int*     Copy_PTR;
   double   elapsed_time;
   time_t   start_time, stop_time; // time_t is defined in time.h

   // METHOD ONE 
   cout << "Starting calculation - please wait...\n";
   start_time = time(NULL);  
   
   for (long pass = 0; pass <= NUM_PASSES; pass++)
      { 
      Orig_PTR = &Original[0][0][0];
      Copy_PTR = &Copy[0][0][0];
   
      for (int i = 0; i < DIM1; i++)
         {
         for (int j = 0; j < DIM2; j++)
            {
            for (int k = 0; k < DIM3; k++)
               {
               *Copy_PTR = *Orig_PTR;
               Orig_PTR++;
               Copy_PTR++;
               }                  
            }
         }
      }

   stop_time = time(NULL);
   elapsed_time = difftime(stop_time, start_time);
   cout << "Using pointers, time (in seconds) : " 
        << elapsed_time << endl; 
   cout << "Starting second calculation - please wait...\n";
    
   // METHOD TWO 
   start_time = time(NULL);
   
   for (pass = 0; pass <= NUM_PASSES; pass++)
      { 
      for (int i = 0; i < DIM1; i++)
         {
         for (int j = 0; j < DIM2; j++)
            {
            for (int k = 0; k < DIM3; k++)
               {
               Copy[i][j][k] = Original[i][j][k];
               }                  
            }
         }
      }
             
   stop_time = time(NULL);   
   elapsed_time = difftime(stop_time, start_time);
   cout << "Using indexing, time (in seconds) : " 
        << elapsed_time << endl; 
    
   return 0;    
   }
