// Demonstrating basic maths and MS graphics library functions
// Source is: 09_21.CPP

// NOTE: This program makes extensive use of implementation
//       dependent graphics functions.  All function names
//       preceded by an underscore are Microsoft specific.  

#include <graph.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <stdio.h>

int main()
   {
   char buffer[80]; 
   float const PI = 3.141512657f;
   double sum[362] = {0.0};
   int old_x, old_y;
   float radians;
   int x, y, color = 1;
   struct _videoconfig v; 
   
   // Find a valid graphics mode 
   if(!_setvideomode(_MAXCOLORMODE))
      {
      exit(1);
      }
   _getvideoconfig( &v ); 

   int x_max = v.numxpixels;
   int y_max = v.numypixels;
 
   // Calculate result
   for (long harmonic = 1; harmonic < 6; harmonic+=2)
      {
      for (int degrees = 0; degrees <= 360; degrees++)
         {
         radians = 2 * PI * degrees/360.0f * harmonic;
         sum[degrees] += sin(radians);
         }
      }

   double sum_max = -1000, sum_min = 1000;

   for (int degrees = 0; degrees <= 360; degrees++)
         {
         if (sum[degrees] > sum_max)
            {
            sum_max = sum[degrees];
            }

         if (sum[degrees] < sum_min)
            {
            sum_min = sum[degrees];
            }
         }

   // Display result
   old_x = 0;
   old_y = y_max / 2;
   
   _setbkcolor(1);
   
   for (degrees = 0; degrees <= 360; degrees++)
         {
         x = (int)((degrees/360.0) * x_max);
         y = y_max - (int)(((sum[degrees]-sum_min)
                     /(sum_max-sum_min))*y_max);
                 
         _moveto(old_x,old_y);
         _lineto(x,y);
         old_x = x;
         old_y = y;  
         }

   _settextposition(20,10);
   sprintf(buffer, "Sum of %d Odd Harmonics", harmonic/2);
   _outtext( buffer );

   return 0;
   }
