// Illustrating the use of drivers
// Source is: 11_02.CPP

#include <iostream.h>
#include <limits.h>

// Function prototype              
int Multiply (const int, const int, int&);           
                              
int main(void)
   {
   long a,b;    // N.B!!!
   int  c;

   // Tell user what the program does
   cout << "Driver Program for Multiply Function\n";
   cout << "------------------------------------\n";

int key[3] = {INT_MIN, 0, INT_MAX};

// First, test end points and any other key values
for (a = 0; a < 3; a+=1)
       {
       for (b = 0; b < 3; b+=1)
          {
          cout << key[a] << " x " << key[b] << " = " 
               << (float) key[a] * key[b] << "\n";

          if (Multiply(key[a],key[b],c))
             {
             cout << "Numbers too large !!!\n";
             }
 
          cout << "Result : " << c << "\n\n";
          }
        }

   // Now test (part of) the rest of the range
   for (a = INT_MAX-1; a > INT_MIN; a-=20000)
       {
       for (b = INT_MAX-1; b > INT_MIN; b-=20000)
          {
          cout << (int) a << " x " << (int) b << " = " 
               << (float) a * b << "\n";

          if (Multiply((int) a, (int) b,c))
             {
             cout << "Numbers too large !!!\n";
             }
 
          cout << "Result : " << c << "\n\n";
          }
        }
   
   cout << "Test complete.";

   return 0;
   }

/***********************************************************
*                                                          *
*  FUNCTION:   Multiply                                    *
*                                                          *
*  PURPOSE:    Multiplies two integers (NUM1 * NUM2)       *
*              returning the result via result.            *
*                                                          *
*  PRE:        NUM1,NUM2 are integers (not checked)        *
*  POST:       result = NUM1 * NUM2   (not checked)        *
*                                                          *
*  ERROR CODE: 0 = Normal completion                       *
*              1 = Product greater than INT_MAX            *
*                  (result = 0)                            *
*                                                          *
***********************************************************/
int Multiply(const int NUM1, const int NUM2, int& result_REF)
   {
   int error_code;

   float Test = (float) NUM1 * NUM2;   // NB (float)
                        
   // INT_MAX - defined in LIMITS.H 
   if (Test > INT_MAX)
      {
      // product too large to represent as type int
      result_REF = 0;
      error_code = 1;
      }
   else
      {
      // Can represent product as int: do so
      result_REF = NUM1 * NUM2;
      error_code = 0;
      }
   
   return error_code;
   }
