/***********************************************************
*                                                          *
* ATM Driver program                                       *
*                                                          *
* Source is:     16_02.CPP                                 *
* Created:       30 Jun, 1995                              *
* Last edited:   07 Mar, 1997                              *
*                                                          *
***********************************************************/

#include <assert.h>
#include <iostream.h>
#include <stdlib.h>
#include <time.h>

// Maximum number of tries allowed to enter correct password
const int MAX_NUM_PASS_TRIES   = 3;

// Various "flags"
const int TRUE = 1;
const int FALSE = 0;

const int ORDER_CHEQUE_BOOK             = 15;
const int PRINT_BALANCE                 = 16;
const int PRINT_MINI_STATEMENT          = 17;
const int DISPENSE_CASH                 = 18;
const int QUIT                          = 19;

// Function prototypes 
void Get_required_service(int&, const int, const int, const int, const int);

/***********************************************************
*                                                          *
*   FUNCTION: main()                                       *
*                                                          *
***********************************************************/
int main(void)
   {
   int choice;

   cout << "DRIVER PROGRAM: Get_required_services()\n\n";

   Get_required_service(choice, 0,0,0,0);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 0,0,0,1);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 0,0,1,0);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 0,0,1,1);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 0,1,0,0);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 0,1,0,1);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 0,1,1,0);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 0,1,1,1);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 1,0,0,0);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 1,0,0,1);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 1,0,1,0);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 1,0,1,1);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 1,1,0,0);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 1,1,0,1);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 1,1,1,0);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 1,1,1,1);
   cout << "Choice = " << choice << "\n\n";

   Get_required_service(choice, 4,7,9,0);
   cout << "Choice = " << choice << "\n\n";
   Get_required_service(choice, 4,5,-1,3);
   cout << "Choice = " << choice << "\n\n";

   cout << "TEST COMPLETE";
   return 0;
   }


/***********************************************************
*                                                          *
*   FUNCTION: Get_required_service()                       *
*                                                          *
*   OVERVIEW: Find out what service user requires.         *
*                                                          *
*   PRE:      No hardware faults.                          *
*   POST:     Got valid choice.                            *
*                                                          *
*   RETURNS:  void.                                        *
*                                                          *
***********************************************************/
void Get_required_service(int&      service_REF,
                          const int cheque_OK,
                          const int balance_OK,
                          const int statement_OK,
                          const int cash_OK)
   {
   // Pre - no hardware faults
   // if (Hardware_fault_detected()) { Shutdown(); }

   int service;

   cout << "Which service do you require: \n";
                     cout << "Quit              -  Type 1\n";
   if (cheque_OK)    cout << "Order cheque book -  Type 2\n";
   if (balance_OK)   cout << "Print balance     -  Type 3\n";
   if (statement_OK) cout << "Print statement   -  Type 4\n";
   if (cash_OK)      cout << "Cash              -  Type 5\n";

   do {
      cout << "Please enter the appropriate number : "; 
      cin >> service;
      } while ((service > 5) 
               || (service < 1)
               || ((service == 2) && (!cheque_OK))
               || ((service == 3) && (!balance_OK))
               || ((service == 4) && (!statement_OK))
               || ((service == 5) && (!cash_OK)));
   
   cout << "Thank you.\n\n";
   
   switch (service)
      {
      case 1: service_REF = QUIT; break;
      case 2: service_REF = ORDER_CHEQUE_BOOK; break; 
      case 3: service_REF = PRINT_BALANCE; break;
      case 4: service_REF = PRINT_MINI_STATEMENT; break;
      case 5: service_REF = DISPENSE_CASH; break;
      }

   // Post - got valid choice
   assert((service_REF == QUIT) ||
          (service_REF == ORDER_CHEQUE_BOOK) ||
          (service_REF == PRINT_BALANCE) ||
          (service_REF == PRINT_MINI_STATEMENT) ||
          (service_REF == DISPENSE_CASH));
   }
