// A simple dynamic array 
// Source is: 18_02.CPP

#include <iostream.h>
#include <stdlib.h> 

int main()
   {
   long  array_size;
   int*  array_PTR;
   
   cout << "What size of array would you like to make? ";
   cin >> array_size;
   
   // Must ensure value is appropriate
   if (array_size < 0)
      {
      cerr << "\n*** Inappropriate size - aborting ***\n";
      exit(1); 
      }
   else
      {   
      cout << "Array size : " << array_size << endl;
   
      // (Try to) grab some "free store" for the array
      array_PTR = new int[array_size];
   
      if (array_PTR == 0)
         {
         cerr << "\n*** Unable to allocate memory - aborting ***\n";
         exit(1);
         }
      else
         {
         // Initialise new array
         for (long i = 0; i < array_size; i++)
            {
            array_PTR[i] = 0;
            } 
      
         cout << "Array created and initialised successfully.\n";
      
         // Return memory to free store
         delete [] array_PTR;   
         array_PTR = 0;
         cout << "Array deleted.\n";
         }
      }         
    
   return 0;
   }
