// Simple car parking program
// Source is: 21_01.CPP

#include <iostream.h> 
#include <stdlib.h>

// Global constants
const int EMPLOYEES = 2;  // Number of employees
const int CARS = 2;       // Number of cars

const int STR_SIZE = 20;  // All strings are this length...

// The data "declarations"
struct sEmployee
   {
   char Payroll[STR_SIZE];    
   char Name[STR_SIZE];     
   char Dept[STR_SIZE];    
   };

struct sCar
   {
   char       RegNum[STR_SIZE];
   char       Make[STR_SIZE];
   char       Colour[STR_SIZE];
   sEmployee* Driver_PTR;
   };

// Function declarations
void Get_Employee_Data(sEmployee&);
void Get_Car_Data(sCar&, const sEmployee* const);
void Display_All_Data(const sCar* const);

int main()
   {
   sEmployee Employees[EMPLOYEES]; // The employees "table"
   sCar Cars[CARS];                // The cars "table"
 
   cout << "Parking Program\n";
   cout << "---------------\n";
 
   // Add some employee data 
   for (int Emp_num = 0; Emp_num < EMPLOYEES; Emp_num++)
      {
      cout << "\nPlease enter details for employee #"
           << Emp_num << "\n";

      Get_Employee_Data(Employees[Emp_num]);
      }

   // Add some car data 
   for (int Car_num = 0; Car_num < CARS; Car_num++)
      {
      cout << "\nPlease enter details for car #"
           << Car_num << "\n";
      
      Get_Car_Data(Cars[Car_num], &Employees[0]);
      }

   // Now display all data
   Display_All_Data(&Cars[0]);

   cout << "\nFinished.";

   return 0;
   }
                   
                   
/***********************************************************
*                                                          *
*   FUNCTION:  Get_Employee_Data                           *
*                                                          *
*   PURPOSE:   Get data for specified employee.            *
*                                                          *
***********************************************************/ 
void Get_Employee_Data(sEmployee& Employee_REF)
   {
   cout << "Employee surname           : ";
   cin.getline(Employee_REF.Name, STR_SIZE);

   cout << "Employee payroll number    : ";
   cin.getline(Employee_REF.Payroll, STR_SIZE);

   cout << "Employee department number : ";
   cin.getline(Employee_REF.Dept, STR_SIZE);
   }
                   
                   
/***********************************************************
*                                                          *
*   FUNCTION:  Get_Car_Data                                *
*                                                          *
*   PURPOSE:   Get data for specified vehicle.             *
*                                                          *
***********************************************************/ 
void Get_Car_Data(                 sCar& Car_REF,
                  const sEmployee* const Employee_PTR)
   {
   cout << "Registration number        : ";
   cin.getline(Car_REF.RegNum, STR_SIZE);

   cout << "Make                       : ";
   cin.getline(Car_REF.Make, STR_SIZE);

   cout << "Colour                     : ";
   cin.getline(Car_REF.Colour, STR_SIZE);

   cout << "\nEmployees:\n";

   for (int Emp_num = 0; Emp_num < EMPLOYEES; Emp_num++)
      {
      cout << "  " << Emp_num << "   "
           << Employee_PTR[Emp_num].Name << "\n";
      }

   char Num_str[5];
   cout << "\nPlease enter employee number of driver : ";
   cin.getline(Num_str, sizeof(Num_str));

   Car_REF.Driver_PTR = (sEmployee*) &(Employee_PTR[atoi(Num_str)]);
   }
                   
                   
/***********************************************************
*                                                          *
*   FUNCTION:  Display_All_Data                            *
*                                                          *
*   PURPOSE:   Display full list of cars with drivers.     *
*                                                          *
***********************************************************/                       
void Display_All_Data(const sCar* const Car_PTR)
   {
   cout << "\nReg.\tMake\tColour\tDriver\n"
        << "------------------------------\n";
   for (int Car = 0; Car < CARS; Car++)
      {
      cout << Car_PTR[Car].RegNum << "\t"
           << Car_PTR[Car].Make   << "\t"
           << Car_PTR[Car].Colour << "\t"
           << (Car_PTR[Car].Driver_PTR)->Name
           << endl;
      }
   }
