// A class example using a copy constructor
// Source is: 25_09.CPP

#include <iostream.h>
#include <stdlib.h>

class cDynamic
   {
   public:
      // Construction / destruction
      cDynamic(const int = 0);   // Default constructor
      cDynamic(const cDynamic&); // Copy constructor
      ~cDynamic();               // Destructor

      // General member functions
      int  Get_Num() const;
      void Set_Num(const int); 

   private:
      int* _Num_PTR;
   };   

cDynamic::cDynamic(const int NUMBER)
   {
   cout << "*** Constructing a cDynamic object (" 
        << NUMBER << ") ***\n";
         
   _Num_PTR = new int;
   
   if (_Num_PTR == 0)
      {
      cerr << "Unable to allocate memory - aborting program\n";
      exit(1);
      }
   else
      {   
      *_Num_PTR = NUMBER;
      }
   }
                     
cDynamic::cDynamic(const cDynamic& DYNAMIC)
   {
   cout << "*** Copy constructing a cDynamic object ***\n"; 
   _Num_PTR = new int;
   
   if (_Num_PTR == 0)
      {
      cerr << "Unable to allocate memory - aborting program\n";
      exit(1);
      }
   else
      {   
      *_Num_PTR = *(DYNAMIC._Num_PTR);
      }
   }


cDynamic::~cDynamic()
   {
   cout << "*** Destructing a cDynamic object ***\n";
   delete _Num_PTR;
   _Num_PTR = 0;
   }

int cDynamic::Get_Num() const
   {
   return *_Num_PTR;
   }

void cDynamic::Set_Num(const int I)
   {
   *_Num_PTR = I;
   }

// Ordinary function prototype
int Ordinary_Function(cDynamic);

int main()
   {
   // Create a cDynamic object
   cout << "About to create new object\n";
   cDynamic one;
  
   one.Set_Num(1); // Set value of private data

   // Create new object
   cout << "\nAbout to create new (copy) object\n";
   cDynamic two(one);    // Explicit call of copy constructor

   // Create new object
   cout << "\nAbout to create new (copy) object\n";
   cDynamic three = two; // Implicit call of copy constructor

   cout << "\nAbout to call Ordinary_Function() by value\n";
   Ordinary_Function(two);

   cout << "\nAbout to try ordinary object copy...\n";
   three = one;

   cout << "\nAbout to leave main()\n";
   return 0;
   }

int Ordinary_Function(cDynamic FunctionObject)
   {
   cout << "Just entered ordinary function\n"; 
   
   FunctionObject.Set_Num(30);
   FunctionObject.Get_Num();   
   
   cout << "Just about to leave ordinary function\n";
   return 0;
   }
