// Demonstrating APO relationships
// Source is: 26_01.CPP

#include <iostream.h>
#include <stdlib.h>
#include <iomanip.h>

enum eBoolean{FALSE, TRUE};

class cPay
   {
   public:
      int&   hours(){return _pay._hourly._hours;};
      float& hourly_rate(){return _pay._hourly._hourly_rate;};
      float& monthly_salary(){return _pay._monthly_salary;};  
   private:
      union // Anonymous
         {
         // Hourly-paid workers
         // Need hours worked, and rate/hour
         struct // Anonymous
            {
            int   _hours;
            float _hourly_rate;
            } _hourly;
         // Salaried workers
         // Just need monthly salary   
         float _monthly_salary;
         } _pay;
   };

class cEmployee
   {
   public:
      void Get_pay_data();
      void Print_gross_pay();
   private:
      char     _surname[20];
      eBoolean _hourly_paid;
      cPay     _pay;  // cPay is APO cEmployee
   };

void cEmployee::Get_pay_data()
   {
   char text_str[10];

   cout << "EMPLOYEE SURNAME : ";
   cin.getline(_surname, sizeof(_surname));

   cout << "Is employee " << _surname << "\n";
   cout << "* Paid by the HOUR (Type 1 <RETURN>)\n";
   cout << "* Paid by SALARY   (Type 0 <RETURN>)\n";
   cout << " ? : ";

   // NO error checking...
   cin.getline(text_str, sizeof(text_str));  

   if (atoi(text_str))
      {
      _hourly_paid = TRUE;
      }
   else
      {
      _hourly_paid = FALSE;
      }

   if(_hourly_paid == TRUE)
      {
      // Hourly-paid employee
      cout << "How many _hours were worked (whole number) : ";
      cin.getline(text_str, sizeof(text_str));
      _pay.hours() = atoi(text_str);
   
      cout << "What is the hourly rate (.pp) : ";
      cin.getline(text_str, sizeof(text_str));
      _pay.hourly_rate() = (float)atof(text_str);
      }
    else
      {
      // Salaried employee
      cout << "What is the monthly salary (.pp) : ";
      cin.getline(text_str, sizeof(text_str));
      _pay.monthly_salary() = (float)atof(text_str);
      }
   cout << "\n";  
   }

void cEmployee::Print_gross_pay()
   {
   float gross_pay;

   if (_hourly_paid == TRUE)
      {
      gross_pay = _pay.hours() * _pay.hourly_rate();
      }
   else
      {
      gross_pay = _pay.monthly_salary();
      }
   
   cout << setiosflags(ios::fixed)
        << setprecision(2);
   cout << _surname << " " << gross_pay << "\n";
   }


int main ()
   {
   int       emp_num;
   cEmployee payroll[2]; // The payroll "database"
 
   cout << "Basic Payroll Program\n";
   cout << "---------------------\n\n";
 
   for (emp_num = 0; emp_num <= 1; emp_num++)
      {
      payroll[emp_num].Get_pay_data();
      }

   cout << "GROSS PAY\n";
   cout << "---------\n";

   for (emp_num = 0; emp_num <= 1; emp_num++)
      {
      payroll[emp_num].Print_gross_pay();
      }

   cout << "\nPay calculations complete.";

   return 0;
   }
