// A simple money class
// with overloaded +,- and = operators
// Source is: 27_05.CPP

#include <iostream.h>

class cMoney
   {
   public:
             cMoney(const int = 0, const int = 0);
      void   Show() const;
      
      cMoney operator+(const cMoney&) const;
      cMoney operator-(const cMoney&) const;
      cMoney operator=(const cMoney&); 
      
   private:
      int    _Pounds, _Pence;
   };   

cMoney::cMoney(const int PO, const int PE)
   {
   _Pounds = PO;
   _Pence = PE;
   }   
   
void cMoney::Show() const
   {
   if (_Pence < 10)
      {
      cout << "" << _Pounds << ".0" << _Pence << endl;
      }
   else
      {
      cout << "" << _Pounds << "." << _Pence << endl;
      }   
   }        
   
// Overload + relative to cMoney class
cMoney cMoney::operator+(const cMoney& OBJ2) const
   {
   cMoney Sum;
   
   Sum._Pounds = this->_Pounds + OBJ2._Pounds;
   Sum._Pence = this->_Pence + OBJ2._Pence;
   
   while (Sum._Pence > 99)
      {
      Sum._Pence-=100;
      Sum._Pounds+=1;
      }     
   
   return Sum;
   }

// Overload - relative to cMoney class
cMoney cMoney::operator-(const cMoney& OBJ2) const
   {
   cMoney Diff;
   
   Diff._Pounds = this->_Pounds - OBJ2._Pounds;
   Diff._Pence = this->_Pence - OBJ2._Pence;
   
   if (Diff._Pence < 0)
      {
      Diff._Pence+=100;
      Diff._Pounds-=1;
      }     
   
   return Diff;
   }

// Overload = relative to cMoney class
cMoney cMoney::operator=(const cMoney& OBJ2)
   {
   this->_Pounds = OBJ2._Pounds;
   this->_Pence = OBJ2._Pence;
   
   return *this;
   }


int main()
   {
   cMoney cash1(1,33), cash2(2,90), cash3;
   
   cash3 = cash1 + cash2;  
   cash3.Show(); 
   
   cash3 = cash2 - cash1;
   cash3.Show();

   cash3 = cash2 = cash1;
   cash1.Show();
   cash2.Show();
   cash3.Show();

   return 0;
   }
