// A simple money class with
// overloaded unary and binary operators
// Source is: 27_08.CPP

#include <iostream.h>

class cMoney
   {
   public:
      cMoney(const int = 0, const int = 0);
      void Show() const;
      cMoney operator-(const cMoney&) const; // Binary version
      cMoney operator-();                    // Unary version
      cMoney operator+(const cMoney&) const; // Binary version
      cMoney operator++();                   // Prefix
      cMoney operator++(int);                // Postfix
      int operator>(const cMoney&) const;
   private:
      int _Pounds, _Pence;
   };   

cMoney::cMoney(const int PO, const int PE)
   {
   _Pounds = PO;
   _Pence = PE;
   }   
   
void cMoney::Show() const
   { 
   if (_Pounds < 0)
      {
      cout << "-" << -_Pounds;
      }
   else
      {
      cout << "" << _Pounds;
      }   
   
   if (_Pence < 10)
      {
      cout << ".0" << _Pence << endl;
      }
   else
      {
      cout << "." << _Pence << endl;
      }   
   }        

// Overload binary - relative to cMoney class
cMoney cMoney::operator-(const cMoney& OBJ2) const
   {
   cMoney Diff;
   
   Diff._Pounds = this->_Pounds - OBJ2._Pounds;
   Diff._Pence = this->_Pence - OBJ2._Pence;
   
   if (Diff._Pence < 0)
      {
      Diff._Pence+=100;
      Diff._Pounds-=1;
      }     
   
   return Diff;
   }

// Overload unary - relative to cMoney class
cMoney cMoney::operator-()
   {
   this->_Pounds = -this->_Pounds;
   return *this;
   }

// Overload binary + relative to cMoney class
cMoney cMoney::operator+(const cMoney& OBJ2) const
   {
   cMoney Sum;
   
   Sum._Pounds = this->_Pounds + OBJ2._Pounds;
   Sum._Pence = this->_Pence + OBJ2._Pence;
   
   while (Sum._Pence > 99)
      {
      Sum._Pence-=100;
      Sum._Pounds+=1;
      }     
   
   return Sum;
   }

// Overload unary prefix ++ relative to cMoney class
cMoney cMoney::operator++()
   {
   ++(this->_Pounds);
   ++(this->_Pence);

   if (this->_Pence > 99)
      {
      this->_Pence-=100;
      this->_Pounds+=1;
      }     
   
   return *this;
   }

// Overload unary postfix ++ relative to cMoney class
cMoney cMoney::operator++(int /* DUMMY PARAMETER */)
   {
   cMoney Return_value = *this;
   
   (this->_Pounds)++;
   (this->_Pence)++;
   
   if (this->_Pence > 99)
      {
      this->_Pence-=100;
      this->_Pounds+=1;
      }     
   
   return Return_value;
   }
   
int cMoney::operator>(const cMoney& OBJ2) const
   {
   if (((this->_Pounds > OBJ2._Pounds)
      || ((this->_Pounds == OBJ2._Pounds) 
      && (this->_Pence > OBJ2._Pence))))
      {
      return 1;
      }
   else
      {
      return 0;
      }   
   }

int main()
   {
   cMoney Cash1(1,01), Cash2(2,00), Cash3;
   
   
   Cash3 = Cash1; 
   cout << "Cash3 = ";
   Cash3.Show();
   cout << "Cash2 = ";
   Cash2.Show();
   
   if (Cash3++ > Cash2)
      {
      cout << "Cash3++ > Cash2\n";
      }
   else
      {
      cout << "Cash3++ <= Cash2\n";
      }            
      
   cout << "Cash3 = ";
   Cash3.Show();
   cout << "Cash2 = ";
   Cash2.Show();
   cout << endl;

   Cash3 = Cash1;  
   cout << "Cash3 = ";
   Cash3.Show();
   cout << "Cash2 = ";
   Cash2.Show();

   if (++Cash3 > Cash2)
      {
      cout << "++Cash3 > Cash2\n";
      }
   else
      {
      cout << "++Cash3 <= Cash2\n";
      }   

   cout << "Cash3 = ";
   Cash3.Show();
   cout << "Cash2 = ";
   Cash2.Show();
   cout << endl;

   Cash3 = Cash1;  
   cout << "Cash3 = ";
   Cash3.Show();
   cout << "-Cash3 = ";
   (-Cash3).Show();
   
   return 0;
   }
