// A simple cMoney Class with overloaded << and >> operators
// Source is: 27_10.CPP
#include <iostream.h>

class cMoney
   {
   public:
                      cMoney(const int = 0, const int = 0);
               cMoney operator+(const cMoney&) const;
               cMoney operator-(const cMoney&) const;

      friend ostream& operator<<(ostream&, cMoney);
      friend istream& operator>>(istream&, cMoney&);
   private:
      int _Pounds, _Pence;
   };   

cMoney::cMoney(const int po, const int pe)
   {
   _Pounds = po;
   _Pence = pe;
   }   
   
// Overload + relative to cMoney class
cMoney cMoney::operator+(const cMoney& obj2) const
   {
   cMoney Sum;
   
   Sum._Pounds = this->_Pounds + obj2._Pounds;
   Sum._Pence = this->_Pence + obj2._Pence;
   
   while (Sum._Pence > 99)
      {
      Sum._Pence-=100;
      Sum._Pounds+=1;
      }     
   
   return Sum;
   }

// Overload - relative to cMoney class
cMoney cMoney::operator-(const cMoney& obj2) const
   {
   cMoney Diff;
   
   Diff._Pounds = this->_Pounds - obj2._Pounds;
   Diff._Pence = this->_Pence - obj2._Pence;
   
   if (Diff._Pence < 0)
      {
      Diff._Pence+=100;
      Diff._Pounds-=1;
      }     
   
   return Diff;
   }

ostream& operator<<(ostream& stream, cMoney object)
   {
   if (object._Pounds < 0)
      {
      stream << "-" << -object._Pounds;
      }
   else
      {
      stream << "" << object._Pounds;
      }   
   
   if (object._Pence < 10)
      {
      stream << ".0" << object._Pence;
      }
   else
      {
      stream << "." << object._Pence;
      } 
      
   return stream;      
   }
   
istream& operator>>(istream& stream, cMoney& object)
   {
   cout << "Please enter cash amount \n";
   cout << "   Pounds : ";
   stream >> object._Pounds;
   cout << "   Pence : ";
   stream >> object._Pence;
   cout << "Thank you.\n\n";

   return stream;
   }           

int main()
   {
   cMoney cash1, cash2, cash3;
   
   cin >> cash1;
   cin >> cash2;
   
   cash3 = cash1 + cash2;  
   cout << "Result of " << cash1 << " + " << cash2 << " = " 
        << cash3 << endl; 

   cash3 = cash1 - cash2;  
   cout << "Result of " << cash1 << " - " << cash2 << " = " 
        << cash3 << endl; 
   
   return 0;
   }
