// A simple generic function
// Source is: 28_02b.CPP

//
// EXTENDED VERSION of 28_02a.CPP - some error checking
// See 'ReadMe28.txt' for details
//
// MJP 15 May, 1997
//

#include <assert.h>
#include <iostream.h>

// Declaration of Copy() - v3.0
template <typename T1,  typename T2> 
void Copy(T1* const To_PTR, const T2* const FROM_PTR, const int SIZE); 

int main()
   {
   int    Ints[5] = {99,99,99,99,99};
   float  Floats[5] = {0.0f};
   double Doubles[5] = {0.0};

   cout << "Before copying :\n";
   for (int p = 0; p < 5; ++p)
      {
      cout << Floats[p] << " ";
      }
   cout << endl;

   // Copy int array to float array...
   Copy(Floats, Ints, 5); 

   // Try to copy doubles array to floats array...
   // WILL GENERATE AN ASSERTION FAILURE...
   Copy(Floats, Doubles, 5); 

   cout << "After copying :\n";
   for (p = 0; p < 5; ++p)
      {
      cout << Floats[p] << " ";
      }
   cout << endl;

   return 0;
   }

// The generic function Copy() - v3.0
template <typename T1,  typename T2>
void Copy(T1* const To_PTR, const T2* const FROM_PTR, const int SIZE) 
   {
   // Simple error checking...
   assert (sizeof(*To_PTR) >= sizeof(*FROM_PTR));

   for (int Element = 0; Element < SIZE; ++Element)
      {
      To_PTR[Element] = FROM_PTR[Element];
      } 
   }
