// Mixing generic functions and ordinary functions
// Source is: 28_03a.CPP

//
// Version of 28_03.CPP compatible with older C++ compilers
// - See ReadMe28.txt for details
//  

#include <iostream.h>

// Declaration of generic function Copy()
template <typename TYPE> 
void Copy(TYPE* const To_PTR, const TYPE* const FROM_PTR, const int SIZE); 

// Declaration of ordinary function Copy()
void Copy(int* const, const char* const, const int); 

int main()
   {
   int Int1[5] = {99,99,99,99,99};
   int Int2[5] = {1,2,3,4,5};

   char Char1[6] = "XXXXX";
   char Char2[6] = "Hello";

   cout << "Before copying :\n";
   for (int p = 0; p < 5; ++p)
      {
      cout << Int1[p] << " ";
      }
   cout << endl;

   cout << Char1 << endl << endl;

   Copy(Char1, Char2, 5); // Copy char arrays with generic fn.
   Copy(Int1, Char2, 5);  // Copy char to int with ordinary fn.

   cout << "\nAfter copying :\n";
   for (p = 0; p < 5; ++p)
      {
      cout << Int1[p] << " ";
      }
   cout << endl;

   cout << Char1 << endl;

   return 0;
   }

// The definition of generic function Copy()
template <typename TYPE>
void Copy(TYPE* const To_PTR, const TYPE* const FROM_PTR, const int SIZE) 
   {
   for (int Element = 0; Element < SIZE; Element++)
      {
      To_PTR[Element] = FROM_PTR[Element];
      } 
   cout << "I'm a generic function!\n";
   }

// The definition of ordinary function Copy()
void Copy(int* const i_PTR, const char* const C_PTR, const int SIZE)
   {
   for (int Element = 0; Element < SIZE; ++Element)
      {
      i_PTR[Element] = C_PTR[Element];
      } 
   cout << "I'm an ordinary function!\n";
   }
