// A simple generic stack class
// Source is: 28_04.CPP

#include <iostream.h>

// Crude way of setting stack size...
// Compare this with Program 28_06
const int SIZE = 3;

// The generic stack class
template <typename TYPE> 
class cStack
   {
   public:
           cStack() { _Top = 0; } // Constructor
      void Push(const TYPE);      // Push onto stack
      TYPE Pop();                 // Pop from stack
   private:    
      TYPE _Data[SIZE];  // The data
      int  _Top;         // Index of top of stack
   };
   
// Push function 
template <typename TYPE> 
void cStack<TYPE>::Push(const TYPE OBJ)
   {
   if (_Top == SIZE)
      {
      cout << "Sorry, can't push - the stack is full\n";
      }
   else
      {
      cout << "Pushed " << OBJ << " onto the stack.\n";
      _Data[_Top] = OBJ;
      _Top++;
      }
   }
   
// Pop function
template <typename TYPE> 
TYPE cStack<TYPE>::Pop()
   {
   if (_Top == 0)
      {
      cout << "Sorry, can't pop - the stack is empty\n";
      return 0; // Empty stack - return 0
      }
   else
      {
      _Top--;
      cout << "Popped " << _Data[_Top] << " from the stack.\n";
      return _Data[_Top];
      }
    }

int main()
   {
   cout << "Creating a character stack..." << endl;
   cStack<char> Char_stack;
   
   Char_stack.Push('a');
   Char_stack.Push('b');
   Char_stack.Push('c');
   Char_stack.Push('d');

   Char_stack.Pop();
   Char_stack.Pop();
   Char_stack.Pop();
   Char_stack.Pop();
   cout << endl;

   cout << "Creating an integer stack..." << endl;
   cStack<int> Int_stack;
  
   Int_stack.Push(1);
   Int_stack.Push(20);
   Int_stack.Push(300);
   Int_stack.Push(4000);

   Int_stack.Pop();
   Int_stack.Pop();
   Int_stack.Pop();
   Int_stack.Pop();

   return 0;
   }
