// A new generic dynamic array data type
// This time stored in stack area
// Source is: 28_06.CPP

#include <iostream.h>
#include <stdlib.h>
#include <assert.h>

template <typename TYPE, const int SIZE>
class cGenericArray
   {
   public:
            cGenericArray();
      TYPE& operator[](const int);  // Overload [] operator
      int   Get_Size() const;

   private:
      TYPE _Start_PTR[SIZE];  // Array in stack
      int  _Size;
   };

template <typename TYPE, const int SIZE>
cGenericArray<TYPE, SIZE>::cGenericArray()
   {
   assert(SIZE > 0); // Precond

   _Size = SIZE;
   }

template <typename TYPE, const int SIZE>
TYPE& cGenericArray<TYPE, SIZE>::operator[](const int I)
   {
   assert((I >=0) && (I <_Size)); // Precond

   return (_Start_PTR[I]);
   }
   
template <typename TYPE, const int SIZE>
int cGenericArray<TYPE, SIZE>::Get_Size() const
   {
   return (_Size);
   }

int main()
   {
   // Create a couple of integer arrays
   cout << "About to create two new integer arrays\n";
   cGenericArray<int,4> one, two;
  
   one[3] = 0;    // Set values of some elements
   two[2] = 999;

   cout << one[3] << endl;
   cout << two[2] << endl;

   // Create new integer array 
   cout << "About to create new (copy) integer array\n";
   cGenericArray<int,4> three = one;
   cout << three[3] << endl;

   // Create a 2-D array
   cout << "About to create 2-D array\n";
   cGenericArray<cGenericArray<int,3>,3> four;

   four[1][1] = 3;
   cout << four[1][1];

   return 0;
   }
