// Modifying classes through inheritance
// Source is: 29_04.CPP

// Note: Code is slightly updated cf. book version

//
// Inheritance allows the programmer to do two main things:
//
// 1. To EXTEND a base class in a derived class (see Progs 29_01 - 29_03)
//
// 2. To MODIFY the behaviour of a base class by OVERIDING base class
//    member functions.  This 'modified behaviour' is demonstrated
//    in this program.
//
// NOTE: Overiding != Overloading.
//

#include <iostream.h>

class cBase_Class 
   {
   public:
      void Set(const int X) { _b = X;} 
      void Show_B() const { cout << _b << endl;}   
      
   private:
      int _b;
   };

// cDerived_Class is derived from cBase_class
class cDerived_Class : public cBase_Class
   {
   public:
      void Set(const int Y) { _d = Y;}  // The 'Set' function is overidden here 
      void Show_D() const { cout << _d << endl;}
      
   private:
      int _d;
   };

int main()
   {
   cDerived_Class Object; 
   
   Object.Set(10);                  // Which one?
   Object.cBase_Class::Set(10);     // This works...
   Object.cDerived_Class::Set(10);  // This works too...
   
   cout << "Show (base)    : ";
   Object.Show_B();
   cout << "Show (derived) : ";
   Object.Show_D();
   
   return 0;
   }
