// Timing implications of dynamic binding...
// Source is: 29_15.CPP

#include <iostream.h>
#include <time.h>

class cBase_Class 
   {
   public:
                   cBase_Class(const int I = 999){_Bas = I;}
      virtual void Set() {_Bas = 10;}

   private:
      int _Bas;
   };

class cDerived_Class : public cBase_Class 
   {
   public:
           cDerived_Class(const int I = 999) {_Der = I;}
      void Set() {_Der = 10;}

   private:
      int _Der;
   };


int main()
   {
   cBase_Class b1;
   cDerived_Class d1;

   cBase_Class* Base_PTR;

   const long NUM_PASSES = 10000000;
   double     elapsed_time;

   time_t     Start_time, Stop_time; // time_t is defined in time.h

   cout << "Starting calculation - please wait...\n";
   Start_time = time(NULL);  

   for (long i = 0; i <= NUM_PASSES; i++)
        {
        Base_PTR = &b1;     
        Base_PTR->Set();
        Base_PTR = &d1;     
        Base_PTR->Set();
        }    

   Stop_time = time(NULL);
   elapsed_time = difftime(Stop_time, Start_time);
   cout << "Elapsed time (in seconds) : " << elapsed_time << endl; 

   return 0;
   }
