// Playing with pure virtual functions
// Source is: 29_16.CPP

#include <iostream.h>

class cSymbol
   {
   public:
      virtual void Draw() = 0;  // Pure virtual function
   };

class cTerminator : public cSymbol
   {
   public:
      void Draw() { cout << "Draw terminator here" << endl; }
   };

class cProcess : public cSymbol
   {
   public:
      void Draw() { cout << "Draw process here" << endl; }
   };

int main()
   {
   // Array of base class pointers
   cSymbol* SymbolArray[10]; 
   
   int Choice;

   for (int Index = 0; Index < 10; Index++)
      {
      cout << "Type 1 for Term, 2 for Proc :  ";
      cin >> Choice;

      switch(Choice)
         {
         case 1:
            // NOTE: 'delete' is never used
            // - this is for illustrative purposes only...
            SymbolArray[Index] = new cTerminator;
            break;

         case 2:
            SymbolArray[Index] = new cProcess;
            break;
         }
      }

   for (Index = 0; Index < 10; Index++)
      {
      SymbolArray[Index]->Draw();
      }

   return 0;
   }
