// Demonstration of association relationships - v1.0
// Source is: 31_01.CPP

#include <iostream.h>

class cClass; // forward reference

// cAssoc is an associated class
class cAssoc
   {
   public:
      cAssoc() {_a = 999;};
      void Set(const int NUMBER) {_a = NUMBER;};
      void Show() const {cout << _a << endl;};

      // Here, we make cClass a friend
      friend class cClass;

   private:
      int _a;
   };


// cClass needs to know about (NTKA) cAssoc
class cClass
   {
   public:
      cClass(cAssoc*);
      void Set(const int NUMBER) {_c = NUMBER;};
      void Show() const {cout << _c << endl;};

      // Access to private parts of assoc class...
      void Link() {_c = _Assoc_Object_PTR->_a;};

   private:
      int     _c;
      cAssoc* _Assoc_Object_PTR;
   };

cClass::cClass(cAssoc* A_PTR)
   {
   _c = 0;
   _Assoc_Object_PTR = A_PTR;
   }

int main()
   {
   cAssoc AssocObject;
   cClass Object(&AssocObject);

   Object.Show();
   AssocObject.Show();

   Object.Link();   // Link via friend (member) function

   Object.Show();
   AssocObject.Show();

   return 0;
   }
