// Demonstration of association relationships - v2.0
// Source is: 31_02.CPP

#include <iostream.h>

class cClass;  // forward reference

// cAssoc is an associated class
class cAssoc
   {
   public:
      cAssoc() {_a = 999;};
      void Set(const int NUMBER) { _a = NUMBER;};
      void Show() const {cout << _a << endl;};

      // Here, we make (ordinary) function Link() a friend
      friend void Link(cClass&, const cAssoc&);
   private:
      int _a;
   };

// cClass needs to know about (NTKA) cAssoc
// Note: the link is now external...
class cClass
   {
   public:
      cClass() {_c = 0;};
      void Set(int NUMBER) {_c = NUMBER;};
      void Show() const {cout << _c << endl;};

      // Here, we make (ordinary) function Link() a friend
      friend void Link(cClass&, const cAssoc&);
   private:
      int _c;
   };

// Declaration of Assoc()
void Link(cClass&, const cAssoc&);

int main()
   {
   cAssoc AssocObject;
   cClass Object;

   Object.Show();
   AssocObject.Show();

   Link(Object, AssocObject);   // Link via ordinary function

   Object.Show();
   AssocObject.Show();

   return 0;
   }

void Link(cClass& c, const cAssoc& a)
   {
   c._c = a._a;
   }
